pub mod traits;

use traits::*;

fn test_traits() {
    println!("Just an example with plenty of widgets.");

    // Create second Container "Number Addition"
    let mut cnt2 = Box::new(Container::new("Number Addition".to_owned()));
    for (caption, x, y, w, h) in [
        ("First Number", 10.0, 20.0, 40, 10),
        ("Second Number", 10.0, 35.0, 40, 10),
        ("Result", 10.0, 55.0, 40, 10),
    ] {
        // Add three to cnt2 two Widget with Label behavior
        cnt2.add(Widget::new(
            x,
            y,
            w,
            h,
            Box::new(Label::new(caption.to_owned())),
        ));
    }

    for (x, y, w, h) in [
        (50.0, 20.0, 120, 10),
        (50.0, 35.0, 120, 10),
        (50.0, 55.0, 120, 10),
    ] {
        // Add three to cnt2 two Widget with Text behavior
        cnt2.add(Widget::new(x, y, w, h, Box::new(Text::new())));
    }

    for (name, x, y, w, h) in
        [("Add", 50.0, 75.0, 30, 15), ("Clear", 85.0, 75.0, 30, 15)]
    {
        // Add two to cnt2 two Widget with Button behavior
        cnt2.add(Widget::new(
            x,
            y,
            w,
            h,
            Box::new(Button::new(name.to_owned())),
        ));
    }

    // Create firs Container "Window"
    let mut cnt1 = Box::new(Container::new("Window".to_owned()));
    // Add to cnt1 cnt2
    cnt1.add(Widget::new(10.0, 15.0, 180, 105, cnt2));
    // Add a widget with the Button behavior
    cnt1.add(Widget::new(
        160.0,
        145.0,
        10,
        15,
        Box::new(Button::new("Exit".to_owned())),
    ));

    // Create Widget which has the first container
    let mut window = Widget::new(0.0, 0.0, 200, 160, cnt1);

    window.draw();

    println!("\n~~~~~~~ Fist click ~~~~~~~");
    window.click(61.0, 91.0); // click on button Add
    println!("\n~~~~~~~ Second click ~~~~~~~");
    window.click(21.0, 36.0); // clicl on label "First Number"
}

fn main() {
    test_traits();
}
